//+------------------------------------------------------------------+
//|                                               CDF Close Sell.mq4 |
//|                              Marty Asher - asher.marty@gmail.com |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "M.Asher 2011"
#property link      "http://www.metaquotes.net"
#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2

extern string TLineName="Line";
extern color LineColor=Black; extern int LineStyle=STYLE_SOLID;
extern int CloseExtra=50;
extern string AlertWav="alert.wav";
extern int StopLoss = 300;
extern double TakeProfitLevel = 0.0;
extern double RiskPercentage = 0.02;
extern bool SignalMail = False;


bool Alerted = False;

double Lots = 0;
double StopLossLevel = 0;
double StopLossLevel2;
double StopSize;

int Slippage = 3;
int MagicNumber = 0;
int BarCount;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   BarCount = Bars;
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{

double High1 = iHigh(NULL, 0, 1 + 0);
double Low1 = iLow(NULL, 0, 1 + 0);
double Close1 = iClose(NULL, 0, 1 + 0);
double Val = ObjectGetValueByShift(TLineName, 0);

int Total;
int Ticket;
int Order = SIGNAL_NONE; 
int counted_bars=IndicatorCounted();

ObjectCreate(TLineName, OBJ_TREND, 0, Time[25], Bid, Time[0], Ask);
ObjectSet(TLineName, OBJPROP_STYLE, LineStyle);
ObjectSet(TLineName, OBJPROP_COLOR, LineColor);


if (BarCount != Bars && Alerted == false) //Checking that we havnt already put on a trade
 { 
      if (Close1+CloseExtra* Point <= Val) //Initial Sell Procedure
      {    
            //Check free margin
            if (AccountFreeMargin() < 500) 
            {
               Print("We have no money. Free Margin = ", AccountFreeMargin());
               return(0);
            }
            //Check free margin finshed    
       StopLossLevel = Val + StopLoss * Point;
       StopSize = StopLossLevel - Bid;       
       Lots = (AccountFreeMargin() * RiskPercentage)/(StopSize*100000);
       Ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, 0.0 , TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
       PlaySound(AlertWav);     
            //Check for multiple tickets
            if(Ticket > 0) 
            {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) 
            {
	            Print("BUY order opened : ", OrderOpenPrice());
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
	         } 
	         else 
		     {
	        Print("Error opening BUY order : ", GetLastError());
		      }
            }
            //Check for multiple tickets finished
      
      }
 BarCount = Bars;
 Alerted = True; 
 }

//----
//----
   return(0);
}
//+------------------------------------------------------------------+